// Includes
#include <PA9.h>       // Include for PA_Lib
#include "kick1.h"  // Include the sound (found in the data folder in .raw format)
#include "hihat1.h"  // Include the sound (found in the data folder in .raw format)
#include "snare1.h"  // Include the sound (found in the data folder in .raw format)
#include "tom1.h"
#include "tom2.h"
#include "cymbale1.h"
#include "cymbale2.h"
#include "drum.h"


/** play a sound on a free channel
*/
void play(int sample)
{
 u8 channel =   PA_GetFreeSoundChannel();
 switch (sample)
 {
   case 0 : PA_PlaySimpleSound(channel, kick1);break;
   case 1 : PA_PlaySimpleSound(channel, snare1);break;
   case 2 : PA_PlaySimpleSound(channel, hihat1);break;
   case 3 : PA_PlaySimpleSound(channel, tom1);break;
   case 4 : PA_PlaySimpleSound(channel, tom2);break;
   case 5 : PA_PlaySimpleSound(channel, cymbale1);break;
   case 6 : PA_PlaySimpleSound(channel, cymbale2);break;
 }
}

/** calcul la distance  x y */
int distance(int x, int y, int xc, int yc)
{
  return (x-xc)*(x-xc)+(y-yc)*(y-yc);
}

void react(int x, int y)
{
 int r=250;
 PA_OutputText(1, 1, 11, "Stylus Position : %d, %d   ", x,y);
 if (distance(x,y,136,124)<=r)  play(0);
 else if (distance(x,y,100,100)<=r)  play(1);
 else if (distance(x,y,44,68)<=r)  play(2);
 else if (distance(x,y,125,55)<=r)  play(3);
 else if (distance(x,y,200,100)<=r)  play(4);
 else if (distance(x,y,75,25)<=r)  play(5);
 else if (distance(x,y,200,20)<=r)  play(6);


}

void drawDrum() {
  PA_LoadGif(	0,(void*)drum); // Gif File
}


// Function: main()
int main(int argc, char ** argv)
{
	PA_Init();    // Initializes PA_Lib
	PA_InitVBL(); // Initializes a standard VBL
 PA_InitText(1,0); //Indique que l'on ecrit dans l'cran 1 sur l'arrire-plan (background) 0
 PA_Init8bitBg(0, 3); 	// Init a 16 bit Bg on screen 0
	PA_InitSound();  // Init the sound system

 PA_OutputText(1, 1, 3, "FingerDrum by ^w");
	drawDrum();

	// Infinite loop to keep the program running
	while (1)
	{
   if (Stylus.Newpress) react(Stylus.X,Stylus.Y);
		PA_WaitForVBL();
	}

	return 0;
} // End of main()
